<?php

function cashenvoy_config() {
    $configarray = array(
        "FriendlyName" => array("Type" => "System", "Value"=>"CashEnvoy Payment Gateway"),
        "memo" => array("FriendlyName" => "Payment Description", "Type" => "textarea","Rows" => "2",  "Description" => "A short constant description of what the payment is about ", ),
    );
    return $configarray;
}

function cashenvoy_link($params) {

    # Invoice Variables
    $invoiceid = $params['invoiceid'];
    $description = $params["description"];
    $amount = $params['amount']; # Format: ##.##
    $currency = $params['currency']; # Currency Code

    # Client Variables
    $firstname = $params['clientdetails']['firstname'];
    $lastname = $params['clientdetails']['lastname'];
    $email = $params['clientdetails']['email'];
    $address1 = $params['clientdetails']['address1'];
    $address2 = $params['clientdetails']['address2'];
    $city = $params['clientdetails']['city'];
    $state = $params['clientdetails']['state'];
    $postcode = $params['clientdetails']['postcode'];
    $country = $params['clientdetails']['country'];
    $phone = $params['clientdetails']['phonenumber'];

    # System Variables
    $companyname = $params['companyname'];
    $systemurl = $params['systemurl'];
    $currency = $params['currency'];

    # Gateway Specific Variables
    $ce_merchantId = '5' ;
    $ce_customerId = $companyname;
    $ce_memo  = $params['memo'];
    $ce_key ='81739485a5e1c3e969d8ac280dc657c9';

  $cetxref2 = rand(100000000000000, 200000000000000);
    $ce_transactionId = 'CE'.$cetxref2;

    $ce_url = $systemurl.'/modules/gateways/callback/cashenvoyresponse.php?transref='.$ce_transactionId.'&invoiceid='.$invoiceid.'&systemurl='.$systemurl;
//    $ce_transactionId = $invoiceid;
    $data = $ce_key.$ce_transactionId.$amount;
    $ce_signature = hash_hmac('sha256', $data, $ce_key, false);


     //   $gatewayurl ="https://www.cashenvoy.com/webservice/?cmd=cepay";

        $gatewayurl ="https://www.cashenvoy.com/sandbox/?cmd=cepay";



    # Enter your code submit to the gateway...

    $code = '<form method="post" action="'.$gatewayurl.'">
<input type="hidden" name="ce_merchantid" value="'.$ce_merchantId.'" />
<input type="hidden" name="ce_amount" value="'.$amount.'" />
<input type="hidden" name="ce_transref" value="'.$ce_transactionId.'" />
<input type="hidden" name="ce_customerid" value="'.$ce_customerId.'" />
<input type="hidden" name="ce_memo" value="'.$ce_memo.'" />
<input type="hidden" name="ce_notifyurl" value="'.$ce_url.'" />
<input type="hidden" name="ce_signature" value="'.$ce_signature.'" />
<input type="hidden" name="amount" value="'.$amount.'" />
<input type="submit" value="Pay Now" />
</form>';

    return $code;
}



?>